﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals

	Public TYPE_STRING   As String = "xsd:string"
	Public TYPE_INTEGER  As String = "xsd:int"
	Public TYPE_FLOAT    As String = "xsd:float"
	Public TYPE_DATE     As String = "xsd:date"
	Public TYPE_DOUBLE   As String = "xsd:dobule"
	Public TYPE_BINARY   As String = "xsd:base64Binary"
	
	Private UrlWS        As String
	Private functionName As String
	Private Data		 As String
	Private Modules      As Object
	Private EN           As String
End Sub

Public Sub Initialize(Url As String,MethodName As String,Module As Object,EventName As String)
	
	UrlWS        = Url
	functionName = MethodName
	EN           = EventName
	Modules      = Module
	
	Data = $"<soapenv:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:web="${UrlWS}">"$
	Data = Data & CRLF & "<soapenv:Header/>"
	Data = Data & CRLF & "<soapenv:Body>"
	Data = Data & CRLF & $"<web:${MethodName} soapenv:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">"$
	
End Sub

Public Sub AddField(FieldName As String,FieldType As String,FieldValue As String)
	Data = Data & CRLF & $"<${FieldName} xsi:type=${FieldType}>${FieldValue}</${FieldName}>"$
End Sub

Sub SendRequest

	Data = Data & CRLF & $"</web:${functionName}>"$
	Data = Data & CRLF & "</soapenv:Body>"
	Data = Data & CRLF & "</soapenv:Envelope>"
	
	Dim ht1 As HttpJob
	ht1.Initialize("send_data",Me)
	ht1.PostString(UrlWS,Data)
	ht1.GetRequest.SetHeader("SOAPAction", $"${UrlWS}"$)
	ht1.GetRequest.SetHeader("Cache-Control","no-cache")
	ht1.GetRequest.SetHeader("Pragma","no-cache")
	ht1.GetRequest.SetContentType("text/xml; charset=utf-8")
	
	
End Sub

Private Sub JobDone(Job As HttpJob)
	
	If Job.Success Then
		If Job.JobName = "send_data" Then
			If SubExists(Modules,EN) Then
				CallSubDelayed2(Modules,EN,ParseString(Job.GetString2("UTF8")))
			End If
		End If
	Else
		If SubExists(Modules,EN) Then
				CallSubDelayed2(Modules,EN,ParseString(Job.ErrorMessage))
		End If
	End If
	
End Sub

Private Sub ParseString(Data1 As String) As String
	Dim m1 As Matcher
	
	Try
		m1 = Regex.Matcher("<return [^>]*>([\s\S]*?)<\/return>",Data1.Replace(CRLF,""))
		If m1.Find Then
			If m1.GroupCount > 0 Then
				Return m1.Group(1)
			Else
				Return ""
			End If
		Else
			Return ""
		End If 
	Catch
		Return ""
	End Try
	
End Sub